// Copyright (c) 2001-2002 TiVo Inc.
//
// Author: Andy Goodman 

#ifndef __DIO_H__
#define __DIO_H__

#include <asm/qdma.h>

typedef struct _DmaChReqDioT {
  int bytesLeft,bytesTotal;
  unsigned long curPtr;
}DmaChReqDioT;

/*
 * 'ptr' is a virtual memory pointer.
 * 'len' is a length in bytes.
 *
 * BOTH must be aligned on 4 bytes.
 *
 * This gives you back a DmaChReqDioT which
 * you pass to DmaChReqCharGet.
 */
extern void
DmaChReqDioInit(DmaChReqDioT *me,unsigned char *ptr, int len);

/*
 * 'me'  is something you don't care about.
 * 'req' is a pointer to  a request that will
 *       be filled by this function
 *
 * Call this in a loop passing a
 * 'req' each time 'til it returns
 * TRUE indicating that the buffer given
 * in DmaChReqDioInit() is exhaused.
 */
extern bool
DmaChReqDioGet(DmaChReqDioT *me,
	       DmaChReqT *req);
#endif





